Index: /trunk/LMDZ.GENERIC/libf/phystd/soil_settings.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/soil_settings.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/soil_settings.F	(revision 1216)
@@ -1,6 +1,8 @@
-      subroutine soil_settings(nid,ngrid,nsoil,tsurf,tsoil)
-
-      use comsoil_h
-
+      subroutine soil_settings(nid,ngrid,nsoil,tsurf,tsoil,indextime)
+
+!      use netcdf
+      use comsoil_h, only: layer, mlayer, inertiedat, volcapa
+      use iostart, only: inquire_field_ndims, get_var, get_field,
+     &                   inquire_field, inquire_dimension_length
       implicit none
 
@@ -9,4 +11,10 @@
 !
 !  Purpose: Read and/or initialise soil depths and properties
+!
+! Modifications: Aug.2010 EM : use NetCDF90 to load variables (enables using
+!                      r4 or r8 restarts independently of having compiled
+!                      the GCM in r4 or r8)
+!                June 2013 TN : Possibility to read files with a time axis
+!
 !
 !  This subroutine reads from a NetCDF file (opened by the caller)
@@ -26,19 +34,15 @@
 !======================================================================
 
-#include "dimensions.h"
-#include "dimphys.h"
-
-#include "netcdf.inc"
 !======================================================================
 !  arguments
 !  ---------
 !  inputs:
-      integer nid	! Input Netcdf file ID 
-      integer ngrid	! # of horizontal grid points
-      integer nsoil	! # of soil layers
-      integer sta       ! # at which reading starts
-      real tsurf(ngrid) ! surface temperature
+      integer,intent(in) :: nid	! Input Netcdf file ID 
+      integer,intent(in) :: ngrid	! # of horizontal grid points
+      integer,intent(in) :: nsoil	! # of soil layers
+      real,intent(in) :: tsurf(ngrid)   ! surface temperature
+      integer,intent(in) :: indextime	! position on time axis
 !  output:
-      real tsoil(ngrid,nsoilmx)	! soil temperature
+      real,intent(out) :: tsoil(ngrid,nsoil)	! soil temperature
 
 !======================================================================
@@ -50,4 +54,6 @@
       integer ndims	! # of dimensions of read <inertiedat> data
       integer ig,iloop	! loop counters
+      
+      integer edges(3),corner(3) ! to read a specific time
 
       logical :: olddepthdef=.false. ! flag
@@ -70,19 +76,7 @@
       real,parameter :: default_volcapa=1.e6
 
-      integer, dimension(2) :: sta2d
-      integer, dimension(2) :: siz2d
-
-!======================================================================
-
-      !! this is defined in comsoil_h
-      IF (.not.ALLOCATED(layer)) 
-     . ALLOCATE(layer(nsoilmx))
-      IF (.not.ALLOCATED(mlayer)) 
-     . ALLOCATE(mlayer(0:nsoilmx-1))
-      IF (.not.ALLOCATED(inertiedat)) 
-     . ALLOCATE(inertiedat(ngrid,nsoilmx))
-
-      !! this is defined in dimphys.h
-      sta = cursor
+      logical :: found,ok
+      
+!======================================================================
 
 ! 1. Depth coordinate
@@ -91,16 +85,5 @@
 ! 1.1 Start by reading how many layers of soil there are
 
-	ierr=NF_INQ_DIMID(nid,"subsurface_layers",dimid)
-	if (ierr.ne.NF_NOERR) then
-	 write(*,*)'soil_settings: Problem reading <subsurface_layers>'
-	 call abort
-	endif
-
-	ierr=NF_INQ_DIMLEN(nid,dimid,dimlen)
-	if (ierr.ne.NF_NOERR) then
-	 write(*,*)'soil_settings: Problem getting <subsurface_layers>',
-     &             'length'
-	 call abort
-	endif
+        dimlen=inquire_dimension_length("subsurface_layers")
 
         if (dimlen.ne.nsoil) then
@@ -112,20 +95,7 @@
 	endif
 
-      sta2d = (/sta,1/)
-      siz2d = (/ngrid,dimlen/)
-
-
 ! 1.2 Find out the # of dimensions <inertiedat> was defined as using
-!     (in ye old days, thermal inertia was only given at the "surface")
-      ! Look for thermal inertia data
-      ierr=NF_INQ_VARID(nid, "inertiedat", nvarid)
-      if (ierr.NE.NF_NOERR) then
-         write(*,*)'soil_settings: Field <inertiedat> not found!'
-         call abort
-      endif
-
-      ! Read the # of dimensions <inertidat> was defined as using
-      ierr=NF_INQ_VARNDIMS(nid,nvarid,ndims)
-      ! if (ndims.eq.1) then we have the "old 2D-surface" format
+
+      ndims=inquire_field_ndims("inertiedat")
 
 ! 1.3 Read depths values or set olddepthdef flag and values
@@ -147,32 +117,14 @@
 	enddo
       else ! Look for depth 
-        ierr=NF_INQ_VARID(nid,"soildepth",nvarid)
-        if (ierr.ne.NF_NOERR) then
-          write(*,*)'soil_settings: Field <soildepth> not found!'
-	  call abort
-        endif
         ! read <depth> coordinate
         if (interpol) then !put values in oldmlayer
-          if (.not.allocated(oldmlayer)) then
-             allocate(oldmlayer(dimlen),stat=ierr)
-	  endif
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid,nvarid,oldmlayer)
-#else
-           ierr = NF_GET_VAR_REAL(nid,nvarid,oldmlayer)
-#endif
-          if (ierr.ne.NF_NOERR) then
-           write(*,*)'soil_settings: Problem while reading <soildepth>'
-           call abort
+          call get_var("soildepth",oldmlayer,found)
+          if (.not.found) then
+            write(*,*)'soil_settings: Problem while reading <soildepth>'
           endif
         else ! put values in mlayer
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid,nvarid,mlayer)
-#else
-           ierr = NF_GET_VAR_REAL(nid,nvarid,mlayer)
-#endif
-          if (ierr.ne.NF_NOERR) then
-           write(*,*)'soil_settings: Problem while reading <soildepth>'
-           call abort
+          call get_var("soildepth",mlayer,found)
+          if (.not.found) then
+            write(*,*)'soil_settings: Problem while reading <soildepth>'
           endif
         endif !of if (interpol)
@@ -183,6 +135,5 @@
       ! default mlayer distribution, following a power law:
       !  mlayer(k)=lay1*alpha**(k-1/2)
-        lay1=2.e-4  !mars case (nsoilmx=18)
-!        lay1=3.e-2  !earth case (nsoilmx=13)
+        lay1=2.e-4
 	alpha=2
         do iloop=0,nsoil-1
@@ -200,5 +151,5 @@
       enddo
 
-! 2. Volumetric heat capacity (note: it is declared in comsoil.h)
+! 2. Volumetric heat capacity (note: it is declared in comsoil_h)
 ! ---------------------------
 ! "volcapa" is (so far) 0D and written in "controle" table of startfi file 
@@ -214,32 +165,9 @@
 	volcapa=default_volcapa
       endif
-! Look for it
-!      ierr=NF_INQ_VARID(nid,"volcapa",nvarid)
-!      if (ierr.NE.NF_NOERR) then
-!         write(*,*)'soil_settings: Field <volcapa> not found!'
-!         write(*,*)'Initializing Volumetric heat capacity to ',
-!     &             default_volcapa
-!         volcapa=default_volcapa
-!      else
-!#ifdef NC_DOUBLE
-!       ierr = NF_GET_VAR_DOUBLE(nid,nvarid,volcapa)
-!#else
-!       ierr = NF_GET_VAR_REAL(nid,nvarid,volcapa)
-!#endif
-!        if (ierr.ne.NF_NOERR) then
-!	  write(*,*)'soil_settings: Problem while reading <volcapa>'
-!         call abort
-!	endif
-!      endif
-
-! 3. Thermal inertia (note: it is declared in comsoil.h)
+
+! 3. Thermal inertia (note: it is declared in comsoil_h)
 ! ------------------
 
 ! 3.1 Look (again) for thermal inertia data (to reset nvarid)
-      ierr=NF_INQ_VARID(nid, "inertiedat", nvarid)
-      if (ierr.NE.NF_NOERR) then
-         write(*,*)'soil_settings: Field <inertiedat> not found!'
-         call abort
-      endif
 
 ! 3.2 Knowing the # of dimensions <inertidat> was defined as using,
@@ -251,13 +179,9 @@
        ! Read Surface thermal inertia
        allocate(surfinertia(ngrid))
-#ifdef NC_DOUBLE
-       ierr = NF_GET_VARA_DOUBLE(nid, nvarid, sta, ngrid, surfinertia)
-#else
-       ierr = NF_GET_VARA_REAL(nid, nvarid, sta, ngrid, surfinertia)
-#endif
-        if (ierr.NE.NF_NOERR) then
-         write(*,*)'soil_settings: Problem while reading <inertiedat>'
+       call get_field("inertiedat",surfinertia,found)
+       if (.not.found) then
+         write(*,*) "soil_settings: Failed loading <inertiedat>"
          call abort
-        endif
+       endif
        
        write(*,*)' => Building soil thermal inertia (using reference sur
@@ -277,24 +201,17 @@
             stop
            endif
-         endif
-#ifdef NC_DOUBLE
-        ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta2d,siz2d,oldinertiedat)
-#else
-        ierr = NF_GET_VARA_REAL(nid,nvarid,sta2d,siz2d,oldinertiedat)
-#endif
-        if (ierr.NE.NF_NOERR) then
-         write(*,*)'soil_settings: Problem while reading <inertiedat>'
-         call abort
+         endif ! of if (.not.allocated(oldinertiedat))
+        call get_field("inertiedat",oldinertiedat,found)
+        if (.not.found) then
+          write(*,*) "soil_settings: Failed loading <inertiedat>"
+          call abort
         endif
        else ! put values in therm_i
-#ifdef NC_DOUBLE
-        ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta2d,siz2d,inertiedat)
-#else
-        ierr = NF_GET_VARA_REAL(nid,nvarid,sta2d,siz2d,inertiedat)
-#endif
-        if (ierr.NE.NF_NOERR) then
-         write(*,*)'soil_settings: Problem while reading <inertiedat>'
-         call abort
-        endif
+         call get_field("inertiedat",inertiedat,found)
+         if (.not.found) then
+           write(*,*) "soil_settings: Failed loading <inertiedat>"
+           call abort
+         endif
+!        endif
        endif ! of if (interpol)
       endif ! of if (ndims.eq.1)
@@ -303,6 +220,8 @@
 ! -------------------------
 
-      ierr=NF_INQ_VARID(nid,"tsoil",nvarid)
-      if (ierr.ne.NF_NOERR) then
+!      ierr=nf90_inq_varid(nid,"tsoil",nvarid)
+      ok=inquire_field("tsoil")
+!      if (ierr.ne.nf90_noerr) then
+      if (.not.ok) then
         write(*,*)'soil_settings: Field <tsoil> not found!'
 	write(*,*)' => Building <tsoil> from surface values <tsurf>'
@@ -320,25 +239,17 @@
            endif
          endif
-#ifdef NC_DOUBLE
-        ierr=NF_GET_VARA_DOUBLE(nid,nvarid,sta2d,siz2d,oldtsoil)
-#else
-        ierr=NF_GET_VARA_REAL(nid,nvarid,sta2d,siz2d,oldtsoil)
-#endif
-        if (ierr.ne.NF_NOERR) then
-	 write(*,*)'soil_settings: Problem while reading <tsoil>'
-	 call abort
-	endif
+         call get_field("tsoil",oldtsoil,found)
+         if (.not.found) then
+           write(*,*) "soil_settings: Failed loading <tsoil>"
+           call abort
+         endif
        else ! put values in tsoil
-#ifdef NC_DOUBLE
-        ierr=NF_GET_VARA_DOUBLE(nid,nvarid,sta2d,siz2d,tsoil)
-#else
-        ierr=NF_GET_VARA_REAL(nid,nvarid,sta2d,siz2d,tsoil)
-#endif
-        if (ierr.ne.NF_NOERR) then
-	 write(*,*)'soil_settings: Problem while reading <tsoil>'
-	 call abort
-	endif
+         call get_field("tsoil",tsoil,found,timeindex=indextime)
+         if (.not.found) then
+           write(*,*) "soil_settings: Failed loading <tsoil>"
+           call abort
+         endif
        endif ! of if (interpol) 
-      endif
+      endif! of if (.not.ok)
 
 ! 5. If necessary, interpolate soil temperatures and thermal inertias
Index: /trunk/LMDZ.GENERIC/libf/phystd/start2archive.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/start2archive.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/start2archive.F	(revision 1216)
@@ -19,7 +19,9 @@
 c=======================================================================
 
+      use infotrac, only: iniadvtrac, nqtot, tname
       USE comsoil_h
-      USE comgeomfi_h
-
+      USE comgeomfi_h, ONLY: lati, long, area
+!      use control_mod
+      use comgeomphy, only: initcomgeomphy
       implicit none
 
@@ -32,10 +34,10 @@
 #include "logic.h"
 #include "temps.h"
-#include "control.h"
+!#include "control.h"
 #include "ener.h"
 
 #include "dimphys.h"
 #include "planete.h"
-#include"advtrac.h"
+!#include"advtrac.h"
 #include "netcdf.inc"
 
@@ -48,5 +50,5 @@
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       REAL teta(ip1jmp1,llm)                    ! temperature potentielle 
-      REAL q(ip1jmp1,llm,nqmx)               ! champs advectes
+      REAL,ALLOCATABLE :: q(:,:,:)   ! champs advectes
       REAL pks(ip1jmp1)                      ! exner (f pour filtre)
       REAL pk(ip1jmp1,llm)
@@ -63,5 +65,6 @@
       REAL tsoil(ngridmx,nsoilmx) ! Soil temperature
       REAL co2ice(ngridmx)	! CO2 ice layer
-      REAL q2(ngridmx,nlayermx+1),qsurf(ngridmx,nqmx)
+      REAL q2(ngridmx,nlayermx+1)
+      REAL,ALLOCATABLE :: qsurf(:,:)
       REAL emis(ngridmx)
       INTEGER start,length
@@ -83,5 +86,6 @@
       REAL ithS(ip1jmp1,nsoilmx) ! Soil Thermal Inertia
       REAL co2iceS(ip1jmp1)
-      REAL q2S(ip1jmp1,llm+1),qsurfS(ip1jmp1,nqmx)
+      REAL q2S(ip1jmp1,llm+1)
+      REAL,ALLOCATABLE :: qsurfS(:,:)
       REAL emisS(ip1jmp1)
 
@@ -122,6 +126,11 @@
 c-----------------------------------------------------------------------
 
+      CALL defrun_new(99, .TRUE. )
       grireg   = .TRUE.
       cursor = 1 ! added by AS in dimphys.
+
+! initialize "serial/parallel" related stuff
+      CALL init_phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
+      call initcomgeomphy
 
       ! ALLOCATE ARRAYS IN comgeomfi_h (usually done in inifis)
@@ -134,12 +143,14 @@
 c Lecture des donnees
 c=======================================================================
-! Load tracer names:
-      call iniadvtrac(nq,numvanle)
-! Initialize global tracer indexes (stored in tracer.h)
-! ... this has to be done before phyetat0
-      call initracer(ngridmx,nqmx,tnom)
+! Load tracer number and names:
+      call iniadvtrac(nqtot,numvanle)
+
+! allocate arrays:
+      allocate(q(ip1jmp1,llm,nqtot))
+      allocate(qsurf(ngridmx,nqtot))
+      allocate(qsurfS(ip1jmp1,nqtot))
 
       fichnom = 'start.nc'
-      CALL dynetat0(fichnom,nqmx,vcov,ucov,teta,q,masse,
+      CALL dynetat0(fichnom,nqtot,vcov,ucov,teta,q,masse,
      .       ps,phis,timedyn)
 
@@ -173,5 +184,5 @@
       Lmodif=0
 
-      CALL phyetat0 (ngridmx,fichnom,0,Lmodif,nsoilmx,nqmx,day_ini_fi,
+      CALL phyetat0 (ngridmx,fichnom,0,Lmodif,nsoilmx,nqtot,day_ini_fi,
      .      timefi,
      .      tsurf,tsoil,emis,q2,qsurf,
@@ -286,5 +297,5 @@
       call gr_fi_dyn(1,ngridmx,iip1,jjp1,emis,emisS)
       call gr_fi_dyn(llm+1,ngridmx,iip1,jjp1,q2,q2S)
-      call gr_fi_dyn(nqmx,ngridmx,iip1,jjp1,qsurf,qsurfS)
+      call gr_fi_dyn(nqtot,ngridmx,iip1,jjp1,qsurf,qsurfS)
       call gr_fi_dyn(llm,ngridmx,iip1,jjp1,cloudfrac,cloudfracS)
       call gr_fi_dyn(1,ngridmx,iip1,jjp1,hice,hiceS)
@@ -390,15 +401,15 @@
 
 c-----------------------------------------------------------------------
-c Ecriture du champs  q  ( q[1,nqmx] )
-c-----------------------------------------------------------------------
-      do iq=1,nqmx
-        call write_archive(nid,ntime,tnom(iq),'tracer','kg/kg',
+c Ecriture du champs  q  ( q[1,nqtot] )
+c-----------------------------------------------------------------------
+      do iq=1,nqtot
+        call write_archive(nid,ntime,tname(iq),'tracer','kg/kg',
      &         3,q(1,1,iq))
       end do
 c-----------------------------------------------------------------------
-c Ecriture du champs  qsurf  ( qsurf[1,nqmx] )
-c-----------------------------------------------------------------------
-      do iq=1,nqmx
-        txt=trim(tnom(iq))//"_surf"
+c Ecriture du champs  qsurf  ( qsurf[1,nqtot] )
+c-----------------------------------------------------------------------
+      do iq=1,nqtot
+        txt=trim(tname(iq))//"_surf"
         call write_archive(nid,ntime,txt,'Tracer on surface',
      &  'kg.m-2',2,qsurfS(1,iq))
@@ -448,3 +459,5 @@
       ierr=NF_CLOSE(nid)
 
+      write(*,*) "start2archive: All is well that ends well."
+
       end 
Index: /trunk/LMDZ.GENERIC/libf/phystd/stelang.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/stelang.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/stelang.F	(revision 1216)
@@ -65,8 +65,9 @@
 C             ---------
 C
-      INTEGER kgrid
-      REAL ptim1,ptim2,ptim3, pflat
-      REAL psilon(kgrid),pcolon(kgrid),pmu0(kgrid),pfract(kgrid)
-      REAL psilat(kgrid), pcolat(kgrid)
+      INTEGER,INTENT(IN) :: kgrid
+      REAL,INTENT(IN) :: ptim1,ptim2,ptim3, pflat
+      REAL,INTENT(IN) :: psilon(kgrid),pcolon(kgrid)
+      REAL,INTENT(IN) :: psilat(kgrid), pcolat(kgrid)
+      REAL,INTENT(OUT) :: pmu0(kgrid),pfract(kgrid)
 C
       INTEGER jl
@@ -100,5 +101,5 @@
         ztim3=pcolat(jl)*ptim3
         pmu0(jl)=ztim1+ztim2*pcolon(jl)+ztim3*psilon(jl)
-	pmu0(jl)=pmu0(jl)/SQRT(pcolat(jl)**2 + (rap**2) * (psilat(jl)**2))
+	pmu0(jl)=pmu0(jl)/SQRT(pcolat(jl)**2+(rap**2)*(psilat(jl)**2))
 
       ENDDO
Index: /trunk/LMDZ.GENERIC/libf/phystd/surfini.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/surfini.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/surfini.F	(revision 1216)
@@ -1,6 +1,8 @@
       SUBROUTINE surfini(ngrid,nq,qsurf,psolaralb)
 
-      USE surfdat_h
-      USE tracer_h
+      USE surfdat_h, only: albedodat, albedice
+      USE tracer_h, only: igcm_co2_ice
+      use comgeomfi_h, only: lati
+      use planetwide_mod, only: planetwide_maxval, planetwide_minval
 
       IMPLICIT NONE
@@ -17,39 +19,23 @@
 #include "callkeys.h"
 c
-      INTEGER ngrid,ig,icap
-      INTEGER nq
-      REAL  piceco2(ngrid),psolaralb(ngrid)
-      REAL qsurf(ngrid,nq) !tracer on surface (kg/m2)
+      INTEGER,INTENT(IN) :: ngrid
+      INTEGER,INTENT(IN) :: nq
+      REAL,INTENT(OUT) :: psolaralb(ngrid)
+      REAL,INTENT(IN) :: qsurf(ngrid,nq) !tracer on surface (kg/m2)
 
-      EXTERNAL ISMIN,ISMAX
-      INTEGER ISMIN,ISMAX
+      INTEGER :: ig,icap
+      REAL :: min_albedo,max_albedo
 c
 c=======================================================================
 
-c
-c     calcul de piceco2 (kg/m2) a l'etat initial
-c     ------------------------------------------
 
       DO ig=1,ngrid
          psolaralb(ig)=albedodat(ig)
-!         psolaralb(ig,2)=albedodat(ig)
       ENDDO
 
-      PRINT*,'surfini: minimum des donnees albedo',
-     s     albedodat(ISMIN(ngrid,albedodat,1))
-      PRINT*,'surfini: maximum des donnees albedo',
-     s     albedodat(ISMAX(ngrid,albedodat,1))
-
-c      calcul de psolaralb 
-c      -------------------
-!      DO ig=1,ngrid
-c	 IF (water) THEN 
-c	   if (qsurf(ig,nq).gt.0.005) then
-c             psolaralb(ig,1) = 0.4
-c             psolaralb(ig,2) = 0.4 
-c           endif 
-c         ENDIF
-!      ENDDO ! of DO ig=1,ngrid     
-c IF there is more than 5 pr. um of h2o ice but no C02 ice, surface albedo is set to 0.4. 
+      call planetwide_minval(albedodat,min_albedo)
+      call planetwide_maxval(albedodat,max_albedo)
+      write(*,*) 'surfini: minimum corrected albedo',min_albedo
+      write(*,*) 'surfini: maximum corrected albedo',max_albedo
 
       if (igcm_co2_ice.ne.0) then
@@ -57,12 +43,10 @@
         DO ig=1,ngrid
           IF (qsurf(ig,igcm_co2_ice) .GT. 0.) THEN
-             !!!! no good in parallel
-             IF(ig.GT.ngrid/2+1) THEN
-                icap=2
+             IF(lati(ig).LT.0.) THEN
+                icap=2 ! Southern hemisphere
              ELSE
-                icap=1
+                icap=1 ! Northern hemisphere
              ENDIF
              psolaralb(ig) = albedice(icap)
-!             psolaralb(ig,2) =  albedice(icap)
           END IF
         ENDDO ! of DO ig=1,ngrid     
@@ -72,9 +56,8 @@
       endif
 
-      PRINT*,'surfini: minimum des donnees albedo',
-     s     psolaralb(ISMIN(ngrid,psolaralb,1))
-      PRINT*,'surfini: maximum des donnees albedo',
-     s     psolaralb(ISMAX(ngrid,psolaralb,1))
+      call planetwide_minval(psolaralb,min_albedo)
+      call planetwide_maxval(psolaralb,max_albedo)
+      write(*,*) 'surfini: minimum corrected albedo',min_albedo
+      write(*,*) 'surfini: maximum corrected albedo',max_albedo
 
-      RETURN
       END
Index: /trunk/LMDZ.GENERIC/libf/phystd/tabfi.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/tabfi.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/tabfi.F	(revision 1216)
@@ -44,14 +44,14 @@
 c=======================================================================
 ! to use  'getin'
-      use ioipsl_getincom 
-
-      USE surfdat_h
-      use comsoil_h
-      USE comgeomfi_h
+      use ioipsl_getincom , only: getin
+
+      use surfdat_h, only: albedice, emisice, iceradius, dtemisice,
+     &                     emissiv
+      use comsoil_h, only: volcapa
+      use iostart, only: get_var
+      use mod_phys_lmdz_para, only: is_parallel
 
       implicit none
  
-#include "dimensions.h"
-#include "dimphys.h"
 #include "comcstfi.h"
 #include "planete.h"
@@ -63,23 +63,28 @@
 c-----------------------------------------------------------------------
 
-      INTEGER ngrid
-
 c Arguments
 c ---------
-      INTEGER nid,nvarid,tab0
-      INTEGER*4 day_ini
-      INTEGER Lmodif
-      INTEGER lmax
-      REAL p_rad,p_omeg,p_g,p_cpp,p_mugaz,p_daysec,time
+      INTEGER,INTENT(IN) :: ngrid,nid,tab0
+      INTEGER*4,INTENT(OUT) :: day_ini
+      INTEGER,INTENT(IN) :: Lmodif
+      INTEGER,INTENT(OUT) :: lmax
+      REAL,INTENT(OUT) :: p_rad,p_omeg,p_g,p_cpp,p_mugaz,p_daysec,time
 
 c Variables
 c ---------
-      INTEGER length
-      parameter (length = 100)
+      INTEGER,PARAMETER :: length=100
       REAL tab_cntrl(length) ! array in which are stored the run's parameters
-      INTEGER  ierr
+      INTEGER  ierr,nvarid
       INTEGER size
       CHARACTER modif*20
-
+      LOGICAL :: found
+      
+      write(*,*)"tabfi: nid=",nid," tab0=",tab0," Lmodif=",Lmodif
+
+      IF (nid.eq.0) then
+c-----------------------------------------------------------------------
+c  Initialization of various physical constants to defaut values (nid = 0 case)
+c-----------------------------------------------------------------------
+      ELSE
 c-----------------------------------------------------------------------
 c  Initialization of physical constants by reading array tab_cntrl(:)
@@ -88,27 +93,19 @@
 c Read 'controle' array
 c
-      ierr = NF_INQ_VARID (nid, "controle", nvarid)
-      IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "Tabfi: Could not find <controle> data"
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, tab_cntrl)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, tab_cntrl)
-#endif
-      IF (ierr .NE. NF_NOERR) THEN
-         PRINT*, "Tabfi: Failed reading <controle> array"
-         CALL abort
-      ENDIF
-
-       print*,'tabfi: tab_cntrl',tab_cntrl
+
+       call get_var("controle",tab_cntrl,found)
+       if (.not.found) then
+         write(*,*)"tabfi: Failed reading <controle> array"
+         call abort
+       else
+         write(*,*)'tabfi: tab_cntrl',tab_cntrl
+       endif
 c
 c  Initialization of some physical constants
 c informations on physics grid
-      if(ngrid.ne.tab_cntrl(tab0+1)) then
-         print*,'tabfi: WARNING !!! tab_cntrl(tab0+1).ne.ngrid'
-         print*,tab_cntrl(tab0+1),ngrid
-      endif
+!      if(ngrid.ne.tab_cntrl(tab0+1)) then
+!         print*,'tabfi: WARNING !!! tab_cntrl(tab0+1).ne.ngrid'
+!         print*,tab_cntrl(tab0+1),ngrid
+!      endif
       lmax = nint(tab_cntrl(tab0+2))
       day_ini = tab_cntrl(tab0+3)
@@ -146,8 +143,4 @@
 c soil properties
       volcapa = tab_cntrl(tab0+35) ! volumetric heat capacity
-
-
-
-
 c-----------------------------------------------------------------------
 c	Save some constants for later use (as routine arguments)
@@ -160,4 +153,5 @@
       p_rad=rad
 
+      ENDIF    ! end of (nid = 0) 
 
 c-----------------------------------------------------------------------
@@ -209,4 +203,10 @@
 c-----------------------------------------------------------------------
 c	 Modifications...
+! NB: Modifying controls should only be done by newstart, and in seq mode
+      if ((Lmodif.eq.1).and.is_parallel) then
+        write(*,*) "tabfi: Error modifying tab_control should",
+     &             " only happen in serial mode (eg: by newstart)"
+        stop
+      endif
 c-----------------------------------------------------------------------
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/write_archive.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/write_archive.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/write_archive.F	(revision 1216)
@@ -32,10 +32,9 @@
 c=======================================================================
 
+      use comsoil_h, only: nsoilmx
       implicit none
 
 #include "dimensions.h"
-#include "dimphys.h"
 #include "paramet.h"
-#include "control.h"
 #include "comvert.h"
 #include "comgeom.h"
Index: /trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F	(revision 1216)
@@ -39,22 +39,18 @@
 !
 !=================================================================
-
-      USE surfdat_h
-#ifdef CPP_PARA
+      use surfdat_h, only: phisfi
+      use control_mod, only: ecritphy, day_step, iphysiq
       USE mod_phys_lmdz_para, only : is_parallel, is_mpi_root,
      &                               is_master, gather
       USE mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
-#endif
       implicit none
 
 ! Commons
-#include "dimensions.h"
-#include "dimphys.h"
-#include "paramet.h"
-#include "control.h"
-#include "comvert.h"
-#include "comgeom.h"
-#include "netcdf.inc"
-#include "temps.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comvert.h"
+      include "comgeom.h"
+      include "netcdf.inc"
+      include "temps.h"
 
 ! Arguments on input:
@@ -73,5 +69,5 @@
       real*4,save :: date
 
-      REAL phis(ip1jmp1) ! surface geopotential on extended lonxlat grid
+      REAL phis(ip1jmp1)
 
       integer irythme
@@ -96,9 +92,9 @@
       integer,save :: n_nom_def
       integer :: n
-      integer,parameter :: n_nom_def_max=99
-      character(len=20),save :: nom_def(n_nom_def_max)
+      integer,parameter :: n_nom_def_max=199
+      character(len=120),save :: nom_def(n_nom_def_max)
       logical,save :: firstcall=.true.
-
-      integer dimvert
+      
+#ifndef MESOSCALE
 
 #ifdef CPP_PARA
@@ -113,13 +109,11 @@
       real phisfi_glo(klon_glo) ! surface geopotential on global physics grid
 #else
-      logical,parameter :: is_parallel=.false.
-      logical,parameter :: is_master=.true.
-      logical,parameter :: is_mpi_root=.true.
       real phisfi_glo(ngrid) ! surface geopotential on global physics grid
 #endif
+
 !***************************************************************
 !Sortie des variables au rythme voulu
 
-      irythme = int(ecritphy) ! sortie au rythme de ecritphy
+      irythme = ecritphy ! sortie au rythme de ecritphy
 !     irythme = iconser  ! sortie au rythme des variables de controle
 !     irythme = iphysiq  ! sortie a tous les pas physique
@@ -129,5 +123,4 @@
 !***************************************************************
 
-
 ! At very first call, check if there is a "diagfi.def" to use and read it
 ! -----------------------------------------------------------------------
@@ -135,5 +128,5 @@
          firstcall=.false.
 
-!      Open diagfi.def definition file if there is one:
+  !      Open diagfi.def definition file if there is one:
          open(99,file="diagfi.def",status='old',form='formatted',
      s   iostat=ierr2)
@@ -170,5 +163,4 @@
       end if
 
-
 ! Initialisation of 'firstnom' and create/open the "diagfi.nc" NetCDF file
 ! ------------------------------------------------------------------------
@@ -185,5 +177,5 @@
            stop
          endif
-
+         
          zitau = -1 ! initialize zitau
 
@@ -240,5 +232,5 @@
         ! are undefined; so set them to 1
         iphysiq=1 
-        !JL11 irythme=1
+        irythme=1
         ! NB: 
       endif
@@ -546,4 +538,4 @@
       endif
 
+#endif
       end
-
Index: /trunk/LMDZ.GENERIC/libf/phystd/writediagsoil.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/writediagsoil.F90	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/writediagsoil.F90	(revision 1216)
@@ -10,15 +10,15 @@
 ! (yielding the sought time series of the variable)
 
-#ifdef CPP_PARA
+! Modifs: Aug.2010 Ehouarn: enforce outputs to be real*4
+
+use comsoil_h, only: nsoilmx
+use control_mod, only: ecritphy, day_step, iphysiq
 use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather
 use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
-#endif
 
 implicit none
 
 #include"dimensions.h"
-#include"dimphys.h"
 #include"paramet.h"
-#include"control.h"
 #include"netcdf.inc"
 
@@ -31,15 +31,15 @@
 integer,intent(in) :: dimpx ! dimension of the variable (3,2 or 0)
 real,dimension(ngrid,nsoilmx),intent(in) :: px ! variable
-! Note: nsoilmx is a common parameter set in 'dimphys.h'
+! Note: nsoilmx is a parameter set in 'comsoil_h'
 
 ! Local variables:
-real,dimension(iip1,jjp1,nsoilmx) :: data3 ! to store 3D data on extended lonxlat grid
-! Note iip1,jjp1 known from paramet.h; nsoilmx known from dimphys.h
-real,dimension(iip1,jjp1) :: data2 ! to store 2D data on extended lonxlat grid
-real :: data0 ! to store 0D data
+real*4,dimension(iip1,jjp1,nsoilmx) :: data3 ! to store 3D data
+! Note iip1,jjp1 known from paramet.h; nsoilmx known from comsoil_h
+real*4,dimension(iip1,jjp1) :: data2 ! to store 2D data
+real*4 :: data0 ! to store 0D data
 integer :: i,j,l ! for loops
 integer :: ig0
 
-real,save :: date ! time counter (in elapsed days)
+real*4,save :: date ! time counter (in elapsed days)
 integer,save :: isample ! sample rate at which data is to be written to output
 integer,save :: ntime=0 ! counter to internally store time steps
@@ -63,7 +63,4 @@
 real dx2_glo(iim,jjp1)     ! to store a global 2D (surface) data set
 real px2(ngrid)
-#else
-logical,parameter :: is_master=.true.
-logical,parameter :: is_mpi_root=.true.
 #endif
 
@@ -83,5 +80,5 @@
   
   ! Set output sample rate
-  isample=int(ecritphy) ! same as for diagfi outputs
+  isample=ecritphy ! same as for diagfi outputs
   ! Note ecritphy is known from control.h
   
@@ -128,9 +125,9 @@
      ierr=NF_INQ_VARID(nid,"time",varid)
      ! Add the current value of date to the "time" array
-#ifdef NC_DOUBLE
-     ierr=NF_PUT_VARA_DOUBLE(nid,varid,ntime,1,date)
-#else
+!#ifdef NC_DOUBLE
+!     ierr=NF_PUT_VARA_DOUBLE(nid,varid,ntime,1,date)
+!#else
      ierr=NF_PUT_VARA_REAL(nid,varid,ntime,1,date)
-#endif
+!#endif
      if (ierr.ne.NF_NOERR) then
       write(*,*)"writediagsoil: Failed writing date to time variable"
@@ -203,9 +200,9 @@
   
   ! B.3. Write the slab of data
-#ifdef NC_DOUBLE
-  ierr=NF_PUT_VARA_DOUBLE(nid,varid,corners,edges,data3)
-#else
+!#ifdef NC_DOUBLE
+!  ierr=NF_PUT_VARA_DOUBLE(nid,varid,corners,edges,data3)
+!#else
   ierr=NF_PUT_VARA_REAL(nid,varid,corners,edges,data3)
-#endif
+!#endif
   if (ierr.ne.NF_NOERR) then
     write(*,*) "writediagsoil: Error: Failed writing "//trim(name)//&
@@ -273,9 +270,9 @@
   
   ! B.3. Write the slab of data
-#ifdef NC_DOUBLE
-  ierr=NF_PUT_VARA_DOUBLE(nid,varid,corners,edges,data2)
-#else
+!#ifdef NC_DOUBLE
+!  ierr=NF_PUT_VARA_DOUBLE(nid,varid,corners,edges,data2)
+!#else
   ierr=NF_PUT_VARA_REAL(nid,varid,corners,edges,data2)
-#endif
+!#endif
   if (ierr.ne.NF_NOERR) then
     write(*,*) "writediagsoil: Error: Failed writing "//trim(name)//&
@@ -312,9 +309,9 @@
 
   ! B.3. Write the data
-#ifdef NC_DOUBLE
-  ierr=NF_PUT_VARA_DOUBLE(nid,varid,corners,edges,data0)
-#else
+!#ifdef NC_DOUBLE
+!  ierr=NF_PUT_VARA_DOUBLE(nid,varid,corners,edges,data0)
+!#else
   ierr=NF_PUT_VARA_REAL(nid,varid,corners,edges,data0)
-#endif
+!#endif
   if (ierr.ne.NF_NOERR) then
     write(*,*) "writediagsoil: Error: Failed writing "//trim(name)//&
